// --------------------- interface functions ---------------------
// checksum = 23120


#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "user_stub_EDF6.h"


#define BOSSA_ID_NUM 0xCE
#define IOCTL_CHANGE_PRECISION         _IOW(BOSSA_ID_NUM, 0, int)
#define IOCTL_GET_MISSED_DEADLINES     _IOW(BOSSA_ID_NUM, 1, int)
#define IOCTL_ATTACH                   _IOW(BOSSA_ID_NUM, 255, int)
#define IOCTL_SCHED_YIELD              _IOW(BOSSA_ID_NUM, 2, int)
#define BOSSA_DEVICE_NAME "bossa_EDF6"


struct dev_EDF6_change_precision_struct {
  int new_precision;
};

struct dev_EDF6_get_missed_deadlines_struct {
  int p;
};

struct dev_EDF6_attach_struct {
  int _checksum;
  int p_11;
  int wcet_jiffie_hundredths_12;
  int fps_13;
};

struct dev_EDF6_sched_yield_struct {
  int p;
};

int EDF6_change_precision(int new_precision) {
  struct dev_EDF6_change_precision_struct _data;
  _data.new_precision = new_precision;
  {
    int fd, res;
    fd = open("/dev/misc/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_CHANGE_PRECISION,(char *)&_data);
    if (res) perror("change_precision");
    close(fd);
    return res;
  }
}

int EDF6_get_missed_deadlines(int p) {
  struct dev_EDF6_get_missed_deadlines_struct _data;
  _data.p = p;
  {
    int fd, res;
    fd = open("/dev/misc/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_GET_MISSED_DEADLINES,(char *)&_data);
    if (res < 0) perror("get_missed_deadlines");
    close(fd);
    return res;
  }
}

int EDF6_attach(int p_11, int wcet_jiffie_hundredths_12, int fps_13) {
  struct dev_EDF6_attach_struct _data;
  _data._checksum = 23120;
  _data.p_11 = p_11;
  _data.wcet_jiffie_hundredths_12 = wcet_jiffie_hundredths_12;
  _data.fps_13 = fps_13;
  {
    int fd, res;
    fd = open("/dev/misc/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_ATTACH,(char *)&_data);
    if (res < 0) perror("attach");
    close(fd);
    return res;
  }
}

int EDF6_sched_yield(int p) {
  struct dev_EDF6_sched_yield_struct _data;
  _data.p = p;
  {
    int fd, res;
    fd = open("/dev/misc/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_SCHED_YIELD,(char *)&_data);
    if (res) perror("sched_yield");
    close(fd);
    return res;
  }
}
