// --------------------- interface functions ---------------------
// checksum = 23120


//needs the shared library libbossa.so obtains by : gcc -shared .../bossa/load.c -o /usr/lib/libbossa.so

using System;
using System.Runtime.InteropServices;
using System.Threading;

public class user_EDF6
{


	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_attach_info(int parent);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_connect(int parent, int child, int argc, int *argv);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_connect_root(int new_root, int argc, int *argv);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_disconnect(int tgt);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int bossa_print(string s, int sz);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int scheduler_names(string s, int sz);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void load_module(string s);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int find_scheduler(string b, string s);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void mount(string parent_name, string child_name,
			int child_property_count,
			int *child_properties);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void mount_root(string new_root_name,
			int child_property_count,
			int *child_properties);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void unmount(string tgt_name);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int open(
		string filename,
		uint flags);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int ioctl(int d,
		uint requete,
		void* lpInBuffer);
		//int lpCompletionRoutine);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe void close(int hFile);

	[DllImport("bossa", SetLastError=true, CharSet=CharSet.Unicode)]
	static extern unsafe int system(string command);

public static unsafe int install_module(string path) {
	return system("cil2module " + path);
}

	const uint GENERIC_READ  = 0x80000000;
	const uint GENERIC_WRITE = 0x40000000;
	const uint OPEN_EXISTING = 3;
	const uint FILE_FLAG_NO_BUFFERING = 0x20000000;
	//const  int SIZE_INT = System.Runtime.InteropServices.Marshal.SizeOf(0);
	const  int SIZE_INT = 4;
	const uint IOCTL_BASE = (1U << 30) | (BOSSA_ID_NUM << 8) | (SIZE_INT << 16);


	const uint BOSSA_ID_NUM = 0xCE;
	const uint IOCTL_CHANGE_PRECISION          = IOCTL_BASE | (0 << 0);
	const uint IOCTL_GET_MISSED_DEADLINES      = IOCTL_BASE | (1 << 0);
	const uint IOCTL_ATTACH                    = IOCTL_BASE | (2 << 0);
	const uint IOCTL_SCHED_YIELD               = IOCTL_BASE | (3 << 0);
	private const string _BOSSA_DEVICE_NAME = "bossa_EDF6";





struct dev_EDF6_change_precision_struct {
  public int new_precision;
};

struct dev_EDF6_get_missed_deadlines_struct {
  public int p;
};

struct dev_EDF6_attach_struct {
  int _checksum;
  public int p_11;
  public int wcet_jiffie_hundredths_12;
  public int fps_13;
};

struct dev_EDF6_sched_yield_struct {
  public int p;
};

public static unsafe int EDF6_change_precision(int new_precision) {
  dev_EDF6_change_precision_struct _data;
  _data.new_precision = new_precision;
  {
    int fd, res;
    fd = open("/dev/bossa/" + _BOSSA_DEVICE_NAME, GENERIC_READ | GENERIC_WRITE);
    res = ioctl(fd,IOCTL_CHANGE_PRECISION,&_data);
    if (res!=0) Console.Error.WriteLine("change_precision");
    close(fd);
    return res;
  }
}

public static unsafe int EDF6_get_missed_deadlines(int p) {
  dev_EDF6_get_missed_deadlines_struct _data;
  _data.p = p;
  {
    int fd, res;
    fd = open("/dev/bossa/" + _BOSSA_DEVICE_NAME, GENERIC_READ | GENERIC_WRITE);
    res = ioctl(fd,IOCTL_GET_MISSED_DEADLINES,&_data);
    if (res < 0) Console.Error.WriteLine("get_missed_deadlines");
    close(fd);
    return res;
  }
}

public static unsafe int EDF6_attach(int p_11, int wcet_jiffie_hundredths_12,
                                     int fps_13) {
  dev_EDF6_attach_struct _data;
  _data._checksum = 23120;
  _data.p_11 = p_11;
  _data.wcet_jiffie_hundredths_12 = wcet_jiffie_hundredths_12;
  _data.fps_13 = fps_13;
  {
    int fd, res;
    fd = open("/dev/bossa/" + _BOSSA_DEVICE_NAME, GENERIC_READ | GENERIC_WRITE);
    res = ioctl(fd,IOCTL_ATTACH,&_data);
    if (res < 0) Console.Error.WriteLine("attach");
    close(fd);
    return res;
  }
}

public static unsafe int EDF6_sched_yield(int p) {
  dev_EDF6_sched_yield_struct _data;
  _data.p = p;
  {
    int fd, res;
    fd = open("/dev/bossa/" + _BOSSA_DEVICE_NAME, GENERIC_READ | GENERIC_WRITE);
    res = ioctl(fd,IOCTL_SCHED_YIELD,&_data);
    if (res!=0) Console.Error.WriteLine("sched_yield");
    close(fd);
    return res;
  }
}
}

