// --------------------- interface functions ---------------------
// checksum = 11566


#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "user_stub_Linux_FIFO.h"


#define BOSSA_ID_NUM 0xCE
#define IOCTL_SCHED_SETSCHEDULER     _IOW(BOSSA_ID_NUM, 0, int)
#define IOCTL_SET_PRIORITY           _IOW(BOSSA_ID_NUM, 1, int)
#define IOCTL_ATTACH                 _IOW(BOSSA_ID_NUM, 255, int)
#define BOSSA_DEVICE_NAME "bossa_Linux_FIFO"


struct dev_Linux_FIFO_sched_setscheduler_struct {
  int p;
};

struct dev_Linux_FIFO_set_priority_struct {
  int p;
};

struct dev_Linux_FIFO_attach_struct {
  int _checksum;
  int p_9;
};

int Linux_FIFO_sched_setscheduler(int p) {
  struct dev_Linux_FIFO_sched_setscheduler_struct _data;
  _data.p = p;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_SCHED_SETSCHEDULER,(char *)&_data);
    if (res) perror("sched_setscheduler");
    close(fd);
    return res;
  }
}

int Linux_FIFO_set_priority(int p) {
  struct dev_Linux_FIFO_set_priority_struct _data;
  _data.p = p;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_SET_PRIORITY,(char *)&_data);
    if (res) perror("set_priority");
    close(fd);
    return res;
  }
}

int Linux_FIFO_attach(int p_9) {
  struct dev_Linux_FIFO_attach_struct _data;
  _data._checksum = 11566;
  _data.p_9 = p_9;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_ATTACH,(char *)&_data);
    if (res < 0) perror("attach");
    close(fd);
    return res;
  }
}
